#ifndef __OBJECTMANAGER_H
#define __OBJECTMANAGER_H

/* a header file detailing the functions that must
be implemented by an Object Manager
*/

#include "kernel.h"

// functions
/* OM_init
This inits the object manager. It is passed the list of objects and lights
in the scene. (each object and light has a pointer to the next one in the list)
This function is timmed as the OM preprocessor step
*/
void OM_init(Object*,Light*);

bool OM_intersect(Ray_Info&,Intersect_Info&); // called by K_trace()

bool OM_shadow_test(Ray&,Float,Light*); // called by K_shadow_test()

/* OM_starting_frame()
Called by the kernel when frame i is starting. Can be used
for optimisation purposes (rays dates before i will be called) */
void OM_starting_frame(int i);

void OM_test_results(void); // out put test results to stderr
 
#endif

