#ifndef __POLYGON_H
#define __POLYGON_H

#include "object.h"
#include "vector.h"

// points defined in counterclockwise order as you face the polygon
// local copy of array is made
// polygons are double sided
class Polygon: public Object{
public:
	struct UV {Float u,v;};

	Polygon(Surface_Info& si, int Nverts, Vector* Verts,Float T0,Float T1); 
	virtual bool intersect(Ray&,Float&);
	virtual void aux_info(Ray&,Intersect_Info&,Shade_Info&);
	virtual void compute_extent(L_proj_fn&,Float &min,Float& max,Float,Float);
	virtual bool inside(AA_Box&);



	Vector Pn; Float D; // the plane of the polygon
	int nverts; // number of verticies
	int DA; // index of dominant axis (x=0...)
	Vector* verts;
	UV	*uvs, // holds uv pairs for intersection
		*uvps; // translated uv pairs (uv prime)
};


Object* Create_Polygon(
	int nverts,Vector* verts, Float T0,Float T1,
	Surface_Info=Surface_Info_default);

#endif

