#ifndef __SCENE_H
#define __SCENE_H

#include "colour.h"
#include "kernel.h"
#include "camera.h"
#include "object.h"
#include "light.h"
#include "transform.h"

/* this file is to be included by the user when
specifying a scene */

struct Kernel_Info{
	Float min_weight; // min ray weight
	Float max_depth; // max tree depth
	Colour ambient; // ambient light in scene
	Colour bounding_colour; // colour of 'sky'
	int seg_sub;// linear segment subdivision factor (1)
	bool bv_ify; // treat objects as their bounds (false)
};

// The user must specify this function to create scene
// user can change kernel info settings, but defaults
// are provided
void user_create_scene(Kernel_Info&,Camera&);


// setup functions, called when scene is being created
void K_add_object(Object*);
void K_add_light(Light*);

#endif


