#include <iostream.h>
#include "scene.h"
#include "spheres.h"
#include "polygon.h"
#include "ttransform.h"
#include "nff.h"

#define TIME 6.0
Camera cam;
void user_create_scene(Kernel_Info& ki)
{

#define MAX_OBJS 5

cam.fname="scenes/spiral";
cam.width=100; cam.height=100;
cam.C=
  Create_TVector_ease_through(
    Vector(15,0,4),
    Vector(5.1,0,1),
    0,TIME
  );
cam.look_at=Create_TVector_linear_through(
  Vector(0,0,0),
  Vector(0,0,10),
  0,TIME
);
cam.up=Create_TVector(0,0,1,0,TIME);
cam.f=Create_FN_ease_through(0.07 , 0.07 ,0,TIME);
cam.xs=cam.ys=new FN_constant(0.2,0,TIME);
cam.end_time=TIME; cam.framesec=12.5;
cam.backdrop=Colour(0.4,0.4,0.7);
cam.sub=1;
cam.motion_blur=false;
cam.anti_alias=false;
ki.bounding_colour=Colour(0.4,0.4,0.7);
ki.bounding_colour*=0.7;
ki.ambient=Colour(0.2,0.2,0.2);
ki.bv_ify=false;

K_init_camera(&cam);
Surface_Info si;

si.kdr=0.9; si.ksr=0.9; si.n=10;
si.dcolour=Colour(1,0.4,0.5);
si.rcolour=Colour(1,1,1);

Object** objs;
int nobjs;
objs=NFF_read_file("scenes/disc.nff",nobjs,0,TIME);
//objs=NFF_read_file("scenes/comp1.nff",nobjs);

for(int i=0;i<MAX_OBJS;i++){
  TTransformation *T=new TTransformation(0,TIME);
  T->scale(Create_TVector(1,1,0.1,0,TIME));
  T->rotateZ(Create_FN_linear_through(0,(MAX_OBJS-i+1)*(4*PI),0,TIME));
  T->rotateX(Create_FN_linear_through(0,2*PI,0,TIME));
  TVector vs[3];
  vs[0]=Create_TVector_linear_through(
    Vector(0,4+i,(MAX_OBJS-i+1)*0.1),
    Vector(0,i+1,(MAX_OBJS-i+1)*2),
    0,1
  );
  vs[1]=Create_TVector_linear_through(
    Vector(0,i+1,(MAX_OBJS-i+1)*2),
    Vector(0,i+0.5,(MAX_OBJS-i+1)*6),
    1,4
  );
  vs[2]=Create_TVector_linear_through(
    Vector(0,i,(MAX_OBJS-i+1)*6),
    Vector(0,i,(MAX_OBJS-i+1)*16),
    4,6
  );
  T->translate(Create_TVector_composite(vs,3,0,6));
  T->rotateZ(Create_FN_linear_through(i*2*PI/MAX_OBJS,i*2*PI/MAX_OBJS-8*PI,0,TIME));
  for(int j=0;j<nobjs;j++)
    K_add_object(Transform_Object(objs[j],T) );
}
si.kdr=0.7; si.ksr=0.1; si.n=20;
si.dcolour=Colour(0.2,0.8,0.7);
si.rcolour=Colour(1,1,1);
Vector V[4]={
Vector(9,9,-1),Vector(9,-9,-1),Vector(-9,-9,-1),Vector(-9,9,-1)};
K_add_object(
  Create_Polygon(4,V,0,TIME,si)
);
V[0]=Vector(-9,-9,-1); V[1]=Vector(-9,-6,-1);
V[2]=Vector(-9,-6,20); V[3]=Vector(-9,-9,20);
K_add_object(
  Create_Polygon(4,V,0,TIME,si)
);
V[0]=Vector(-9,9,-1); V[1]=Vector(-9,6,-1);
V[2]=Vector(-9,6,20); V[3]=Vector(-9,9,20);
K_add_object(
  Create_Polygon(4,V,0,TIME,si)
);

K_add_light(new Light(
  TVector(
    new FN_constant(100,0,TIME),
    new FN_constant(0,0,TIME),
    new FN_constant(10,0,TIME)
  ),
  Colour(1,1,1) ) );
K_add_light(new Light(
  TVector(
    new FN_constant(10,0,TIME),
    new FN_constant(10,0,TIME),
    new FN_constant(100,0,TIME)
  ),
  Colour(1,1,1) ) );

}


