#include <iostream.h>
#include "scene.h"
#include "spheres.h"
#include "polygon.h"
#include "ttransform.h"

#define TIME 1
Camera cam;
void user_create_scene(Kernel_Info& ki)
{

#define MAX_SPHS 5

cam.fname="scenes/spiral";
cam.width=200; cam.height=200;
cam.C= TVector(
  Create_FN_sin(1,0,0,5,0,TIME),
  Create_FN_cos(1,0,0,5,0,TIME), 
  Create_FN_linear_through(3,6,0,TIME)
);

cam.look_at=TVector(
  Create_FN_sin(2,0,0,1.6,0,TIME),
  Create_FN_cos(2,0,0,1.6,0,TIME), 
  Create_FN_linear_through(0,3,0,TIME)
);

cam.up=Create_TVector(0,0,1);
cam.f=new FN_constant(1);
cam.xs=new FN_constant(1.8); cam.ys=new FN_constant(1.8);
cam.end_time=TIME; cam.framesec=40;
cam.backdrop=Colour(0.4,0.4,0.7);
ki.bounding_colour=Colour(0.4,0.4,0.7);
ki.bounding_colour*=0.8;
ki.ambient=Colour(0.1,0.1,0.1);

K_init_camera(&cam);
Surface_Info si;

si.kdr=0.9; si.ksr=0.9; si.n=10;
si.dcolour=Colour(1,0.4,0.5);
si.rcolour=Colour(1,1,1);

Object *sphere=Create_Static_Sphere(Vector(0,0,0),1,si);
for(int i=0;i<MAX_SPHS;i++){
	TTransformation *T=new TTransformation;
	T->translate( TVector(
	  Create_FN_sin(2,(PI*2*i)/MAX_SPHS,0,1.6,0,TIME),
	  Create_FN_cos(2,(PI*2*i)/MAX_SPHS,0,1.6,0,TIME), 
	  Create_FN_linear_through(i/Float(MAX_SPHS),3.0*(i+MAX_SPHS)/Float(MAX_SPHS),0,TIME)
	));
	K_add_object(
	  Transform_Object(sphere,T)
	);
}
si.kdr=0.9; si.ksr=0.1; si.n=2;
si.dcolour=Colour(0.2,0.8,0.7);
si.rcolour=Colour(1,1,1);
Vector V[4]={
Vector(5,5,-1),Vector(5,-5,-1),Vector(-5,-5,-1),Vector(-5,5,-1)};
K_add_object(
  Create_Polygon(4,V,si)
);

K_add_light(new Light(
  TVector(
    new FN_constant(10),
    new FN_constant(10),
    new FN_constant(10)
  ),
  Colour(1,1,1) ) );

}


