#include "scene.h"
#include "spheres.h"

#define TIME 3
Camera cam;
void user_create_scene(Kernel_Info& ki)
{

cam.fname="scenes/trans1";
cam.width=200; cam.height=200;
cam.C=
  Create_TVector(-100,0,0);
  /*TVector(
    Create_FN_linear_through(-60,-40,0,TIME),
    new FN_constant(30),
    Create_FN_linear_through(0,-20,0,TIME)
);*/

cam.look_at=Create_TVector(40,0,0);
cam.up=Create_TVector(0,10,0);
cam.f=new FN_constant(10);
cam.xs=new FN_constant(10); cam.ys=new FN_constant(10);
cam.end_time=TIME; cam.framesec=10;
ki.ambient=Colour(0.3,0.3,0.3);

K_init_camera(&cam);
Surface_Info si;

// put large sphere as ground
si.kdr=0.9; si.ksr=0; si.n=3; si.ior=0;
si.dcolour=Colour(0.8,0.9,1);
si.rcolour=Colour(1,1,1);
/*K_add_object(
	Create_Static_Sphere(Vector(500,-10000,0),9900,si)
);*/

// have:
//  few large non-reflective spheres in bacground
//  some small spheres moving randomly next
//  some medium transparent spheres (two moving down, one up)

si.kdr=0.9; si.ksr=0.5; si.n=2;
si.dcolour=Colour(1,0.1,0.1);
K_add_object( Create_Static_Sphere(Vector(500, 100, 100), 95, si));
si.dcolour=Colour(0.1,0.2,1);
K_add_object( Create_Static_Sphere(Vector(500,-100, 100), 95, si));
si.dcolour=Colour(0.3,1,0.1);
K_add_object( Create_Static_Sphere(Vector(500, 100,-100), 95, si));
si.dcolour=Colour(0.4,0.6,0.9);
K_add_object( Create_Static_Sphere(Vector(500,-100,-100), 95, si));

// small spheres
si.kdr=0.5; si.ksr=0.99; si.n=1;
si.rcolour=Colour(1,1,1);
Object* sphere=Create_Static_Sphere(Vector(0,0,0),10);

si.dcolour=Colour(0.3,0.4,0.8);
K_add_object( Translate_Object(sphere,
  Create_TVector_linear_through(Vector(100,80,20),Vector(100,-80,-10),0,TIME),
  si) );

si.dcolour=Colour(0.7,0.2,0.8);
K_add_object( Translate_Object(sphere,
  Create_TVector_linear_through(Vector(75,-20,-80),Vector(75,20,60),0,TIME),
  si) );

si.dcolour=Colour(0.9,0.2,0.4);
K_add_object( Translate_Object(sphere,
  Create_TVector_linear_through(Vector(60,-70,80),Vector(60,70,-80),0,TIME),
  si) );

// transparnet spheres
si.ksr=0.5; si.kdr=0.1; si.kst=0.99; si.n=10; si.ior=1.1;
si.rcolour=Colour(1,1,1); si.dcolour=Colour(1,1,1);
Object* spheret=Create_Static_Sphere(Vector(0,0,0),18);
si.tcolour=Colour(1,1,1);
K_add_object( Translate_Object(spheret,
  Create_TVector_linear_through(Vector(30,60,-40),Vector(30,-60,-40),0,TIME),
  si) );

K_add_object( Translate_Object(spheret,
  Create_TVector_linear_through(Vector(30,60,40),Vector(30,-60,40),0,TIME),
  si) );

K_add_object( Translate_Object(spheret,
  Create_TVector_linear_through(Vector(30,-60,0),Vector(30,60,0),0,TIME),
  si) );


K_add_light(new Light(
  TVector(
    new FN_constant(-10),
    new FN_constant(65),
    new FN_constant(0)
  ),
  Colour(1,1,1) ) );

}


