#include <iostream.h>
#include "scene.h"
#include "spheres.h"
#include "polygon.h"
#include "ttransform.h"
#include "nff.h"
#include "strcom.h"

#define TIME 1.0
void user_create_scene(Kernel_Info& ki,Camera& cam)
{

//STRC.smart_time_divide=true;

cam.fname="test/output";
cam.width=200; cam.height=200;
cam.C=
  Create_TVector(-100,25,25, 0,TIME);
  //Create_TVector_linear_through(Vector(40,0,-50),Vector(40,0,50),0,TIME)
cam.look_at=Create_TVector(0,25,25, 0,TIME);
cam.up=Create_TVector(0,0,1, 0,TIME);
cam.f=new FN_constant( 0.1,0,TIME);
cam.xs=cam.ys=new FN_constant(0.05, 0,TIME);
cam.end_time=TIME; cam.framesec=20;
cam.backdrop=Colour( 0.078,0.361,0.753);
cam.sub=1;
cam.motion_blur=true;
cam.anti_alias=false;
ki.bounding_colour=Colour(1,1,1);
ki.bounding_colour*=0.5;
ki.ambient=Colour(0.2,0.2,0.2);
ki.seg_sub=2;
//ki.bv_ify=true;
Surface_Info si;


#define NUM 100
#define W 50
si.rcolour=Colour(1,1,1);
si.n=2;
for(int i=0;i<NUM;i++){
	si.dcolour=Colour(0.5+K_random()*0.5,0.5+K_random()*0.5,0.5+K_random()*0.5);
	Float f=K_random();
	si.kdr=f; si.ksr=1-f;
	Object* sphere=Create_Static_Sphere(Vector(0,0,0),1+K_random(),0,TIME,si);
	TTransformation *T=new TTransformation(0,TIME);
	int jumps=2.0+K_random()*4;
	Vector start=Vector(K_random()*W,K_random()*W,K_random()*W);
	Vector a,b; a=start;
	Function **fnsx=new Function*[jumps+1];
	Function **fnsy=new Function*[jumps+1];
	Function **fnsz=new Function*[jumps+1];
	Float t=0,wid=TIME/double(jumps+1);
	int j;
	for(j=0;j<jumps;j++){
		b=Vector(K_random()*W,K_random()*W,K_random()*W);
		fnsx[j]=Create_FN_ease_through(a.x,b.x,t,t+wid);
		fnsy[j]=Create_FN_ease_through(a.y,b.y,t,t+wid);
		fnsz[j]=Create_FN_ease_through(a.z,b.z,t,t+wid);
		a=b;
		t+=wid;
	}
	fnsx[j]=Create_FN_ease_through(b.x,start.x,t,TIME);
	fnsy[j]=Create_FN_ease_through(b.y,start.y,t,TIME);
	fnsz[j]=Create_FN_ease_through(b.z,start.z,t,TIME);
	T->translate(TVector(
	  new FN_composite(jumps+1,fnsx,0,TIME),
	  new FN_composite(jumps+1,fnsy,0,TIME),
	  new FN_composite(jumps+1,fnsz,0,TIME)
	));
	K_add_object(Transform_Object(sphere,T));
}

 TVector xx = Create_TVector(-100,-100,100,0,TIME);
K_add_light(new Light(
  xx,
  Colour(1,1,1) ) );

}


