#include <iostream.h>
#include "scene.h"
#include "spheres.h"
#include "polygon.h"
#include "ttransform.h"
#include "nff.h"
#include "strcom.h"

#define TIME 1.0
void user_create_scene(Kernel_Info& ki,Camera& cam)
{

//STRC.smart_time_divide=true;

cam.fname="test/output";
cam.width=200; cam.height=200;
cam.C=
  Create_TVector(-1.6,1.6,1.7, 0,TIME);
  //Create_TVector_linear_through(Vector(40,0,-50),Vector(40,0,50),0,TIME)
cam.look_at=Create_TVector(0,0,0, 0,TIME);
cam.up=Create_TVector(0,0,1, 0,TIME);
cam.f=new FN_constant( 0.07,0,TIME);
cam.xs=cam.ys=new FN_constant(0.07, 0,TIME);
cam.end_time=TIME; cam.framesec=24;
cam.backdrop=Colour( 0.078,0.361,0.753);
cam.sub=3;
cam.motion_blur=true;
cam.anti_alias=true;
ki.bounding_colour=cam.backdrop;
ki.bounding_colour*=0.8;
ki.ambient=Colour(0.2,0.2,0.2);
ki.seg_sub=2;
//ki.bv_ify=true;


int nobjs;
Object** objs;
objs=NFF_read_file("test/mount4.nff",nobjs,0,TIME);
for(int i=0;i<nobjs;i++) K_add_object(objs[i]);

Object* sphere;
Surface_Info si;
si.kdr=1; si.ksr=0.1; si.n=40; si.kst=0.9; si.ior=1.5;
si.dcolour=si.rcolour=si.tcolour=Colour(1,1,1);
sphere=Create_Static_Sphere(Vector(0,0,0),0.17,0,TIME,si);

TTransformation *T=new TTransformation(0,TIME);
T->translate(Create_TVector(0,0,0.17, 0,TIME));
T->rotateX(Create_FN_linear_through(0,2*PI,0,TIME));
T->translate(Create_TVector(0,0,-0.17, 0,TIME));
T->translate(Create_TVector(-0.8,0.8,1.20821,0,TIME));
K_add_object(Transform_Object(sphere,T));

T=new TTransformation(0,TIME);
T->translate(Create_TVector(0,0,0.17, 0,TIME));
T->rotateX(Create_FN_linear_through(0,2*PI,0,TIME));
T->translate(Create_TVector(0,0,-0.17, 0,TIME));
T->translate(Create_TVector(-0.661196,0.661196,0.930598,0,TIME));
K_add_object(Transform_Object(sphere,T));

T=new TTransformation(0,TIME);
T->translate(Create_TVector(0,0,0.17, 0,TIME));
T->rotateX(Create_FN_linear_through(0,2*PI,0,TIME));
T->translate(Create_TVector(0,0,-0.17, 0,TIME));
T->translate(Create_TVector(-0.749194,0.98961,0.930598, 0,TIME));
K_add_object(Transform_Object(sphere,T));

T=new TTransformation(0,TIME);
T->translate(Create_TVector(0,0,0.17, 0,TIME));
T->rotateX(Create_FN_linear_through(0,2*PI,0,TIME));
T->translate(Create_TVector(0,0,-0.17, 0,TIME));
T->translate(Create_TVector(-0.98961,0.749194,0.930598, 0,TIME));
K_add_object(Transform_Object(sphere,T));


 TVector xx = Create_TVector(-100,-50,100, 0,TIME);
K_add_light(new Light(
  xx,
  Colour(0.8,0.8,0.8) ) );

}


