#include <iostream.h>
#include "scene.h"
#include "spheres.h"
#include "polygon.h"
#include "ttransform.h"
#include "nff.h"
#include "strcom.h"

#define TIME 1.0
void user_create_scene(Kernel_Info& ki,Camera& cam)
{

//STRC.smart_time_divide=true;

cam.fname="test/output";
cam.width=200; cam.height=200;
cam.C=
  Create_TVector(0,500,50, 0,TIME);
  //Create_TVector_linear_through(Vector(40,0,-50),Vector(40,0,50),0,TIME)
cam.look_at=Create_TVector(0,0,0, 0,TIME);
cam.up=Create_TVector(0,0,1, 0,TIME);
cam.f=new FN_constant( 0.1,0,TIME);
cam.xs=cam.ys=new FN_constant(0.03, 0,TIME);
cam.end_time=TIME; cam.framesec=20;
cam.backdrop=Colour( 0.078,0.361,0.753);
cam.sub=1;
cam.motion_blur=false;
cam.anti_alias=false;
ki.bounding_colour=Colour(1,1,1);
ki.bounding_colour*=0.2;
ki.ambient=Colour(0.2,0.2,0.2);
ki.seg_sub=4;
//ki.bv_ify=true;
Surface_Info si;

si.kdr=0.9; si.ksr=0.1; si.n=1;
si.dcolour=Colour(0.4,0.8,0.9);
si.rcolour=Colour(1,1,1);

Object** enterp=new Object*[7];
Transformation *T;
Object *sphere=Create_Static_Sphere(Vector(0,0,0),1,0,TIME,si);
// saucer
T=new Transformation;
T->scale(Vector(10,10,1));
T->translate(Vector(0,-6,4));
enterp[0]=Transform_Object(sphere,T);
//body
T=new Transformation;
T->scale(Vector(3,10,1.2));
T->translate(Vector(0,4,0));
enterp[1]=Transform_Object(sphere,T);
//body/saucer join
T=new Transformation;
T->scale(Vector(2,0.7,4.2));
T->rotateX(PI/4);
T->translate(Vector(0,0,2));
enterp[2]=Transform_Object(sphere,T);
// left leg
T=new Transformation;
T->scale(Vector(1.5,7,0.7));
T->translate(Vector(-4,14,3));
enterp[3]=Transform_Object(sphere,T);
T=new Transformation;
T->scale(Vector(0.5,3.8,0.9));
T->rotateX(PI/4);
T->rotateY(PI/4);
T->translate(Vector(2,10,2));
enterp[4]=Transform_Object(sphere,T);
// right leg
T=new Transformation;
T->scale(Vector(1.5,7,0.7));
T->translate(Vector(4,14,3));
enterp[5]=Transform_Object(sphere,T);
T=new Transformation;
T->scale(Vector(0.5,3.8,0.9));
T->rotateX(PI/4);
T->rotateY(-PI/4);
T->translate(Vector(-2,10,2));
enterp[6]=Transform_Object(sphere,T);

TTransformation *TT=new TTransformation(0,TIME);
TT->rotateY(Create_FN_sin(1,0,0,PI/2,0,TIME)); //roll
TT->rotateZ(Create_FN_sin(0.5,0,0,PI,0,TIME)); // rotate
TT->translate(TVector( // figure 8
  Create_FN_sin(2,0,0,-50, 0,TIME),
  Create_FN_sin(1,0,0,-200,0,TIME),
  new FN_constant(0,0,TIME)
));
for(int i=0;i<7;i++)
	K_add_object(Transform_Object(enterp[i],TT));

int nobjs;
Object**objs;
objs=NFF_read_file("test/tetra4.nff",nobjs,0,TIME);
T=new Transformation;
T->scale(Vector(20,20,20));
T->translate(Vector(0,0,-30));
for(i=0;i<nobjs;i++)K_add_object(Transform_Object(objs[i],T));

objs=NFF_read_file("test/balls2.nff",nobjs,0,TIME);
T=new Transformation;
T->scale(Vector(35,35,35));
T->translate(Vector(30,-10,50));
for(i=0;i<nobjs;i++)K_add_object(Transform_Object(objs[i],T));
K_add_light(new Light(
  Create_TVector(0,500,200,0,TIME),
  Colour(0.8,0.8,0.8) ) );
K_add_light(new Light(
  Create_TVector(200,0,-200,0,TIME),
  Colour(0.3,0.3,0.3) ) );
}


